<template>
  <v-dialog
    :value="value"
    max-width="290"
    @click:outside="closeRequest"
    @keydown.esc="closeRequest"
    content-class="round"
  >
    <div class="flex flex-col bg-white p-7 justify-between gap-8 max-w-xs">
      <div class="flex flex-row justify-center">
        <div class="text-xl font-semibold">{{ data.title }}</div>
      </div>
      <v-form
        ref="form"
        v-model="valid"
        @submit.prevent="onModalSubmit"
        lazy-validation
      >
        <v-text-field
          label="Nom de la classe"
          :rules="nomRules"
          v-model="classe.nom"
          required
        ></v-text-field>
        <v-radio-group
          v-show="!updating"
          v-model="classe.typeEvaluations"
          label="Type d'évalutions"
          required
          :rules="[(v) => !!v]"
        >
          <v-radio
            name="Acquis"
            label="Acquis (A. / E.V.A. / N.A.)"
            value="acquis"
          ></v-radio>
          <v-radio name="Cotes" label="Cotes" value="cotes"></v-radio>
        </v-radio-group>
        <div class="flex flex-row-reverse justify-between">
          <div>
            <button
              type="submit"
              class="bg-bleu font-medium text-gray-50 text-sm py-2.5 px-5 rounded-lg hover:bg-bleuHover focus:outline-none"
            >
              {{ updating ? "Modifier" : "Ajouter" }}
            </button>
          </div>
          <div
            id="deleteMatCompSav"
            @click="onDeleteClasse"
            class="cursor-pointer border border-red-400 text-red-400 text-sm py-2.5 px-5 rounded-lg hover:bg-red-400 hover:text-gray-50 focus:outline-none"
            v-show="updating"
          >
            Effacer
          </div>
        </div>
      </v-form>
    </div>
  </v-dialog>
</template>

<script>
export default {
  emits: ["closeRequest, onModalSubmit"],
  props: {
    value: Boolean,
    data: Object,
  },
  data() {
    return {
      valid: false,
      updating: this.data.crud == "update",
      classe: { ...this.data.classe } ?? {},
      nomRules: [(v) => !!v || "Le nom est requis"],
    };
  },

  methods: {
    closeRequest() {
      this.$emit("closeRequest");
    },
    onModalSubmit() {
      if (this.$refs.form.validate()) {
        this.$emit("onModalSubmit", this.classe, this.data.crud);
      }
    },
    onDeleteClasse() {
      this.$emit("onDeleteClasse", this.classe);
    },
  },
};
</script>
